# Generated by Django 4.2.7 on 2023-11-11 20:18

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Route',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('from_station', models.CharField(max_length=100)),
                ('to_station', models.CharField(max_length=100, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='SeatType',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=20, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='Train',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('train_no', models.IntegerField()),
                ('departure_time', models.DateTimeField()),
                ('tatkal_seats', models.IntegerField(default=10)),
                ('available_seat_types', models.ManyToManyField(to='ticket_management.seattype')),
                ('route', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.route')),
            ],
        ),
        migrations.CreateModel(
            name='WaitingList',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('ticket_type', models.CharField(blank=True, max_length=20, null=True)),
                ('waiting_number', models.PositiveIntegerField(blank=True, null=True)),
                ('train', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.train')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TrainSeatType',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('total_seats', models.IntegerField(default=0)),
                ('available_seats', models.IntegerField(default=0)),
                ('seat_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.seattype')),
                ('train', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.train')),
            ],
        ),
        migrations.CreateModel(
            name='Ticket',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.CharField(choices=[('Booked', 'Booked'), ('Waiting', 'Waiting'), ('Cancelled', 'Cancelled')], default='Waiting', max_length=20)),
                ('pnr_number', models.CharField(blank=True, max_length=10, unique=True)),
                ('price', models.DecimalField(decimal_places=2, default=0.0, max_digits=10)),
                ('route', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.route')),
                ('seat_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.seattype')),
                ('train', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.train')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='RouteSeatType',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('base_price_adjustment', models.DecimalField(decimal_places=2, default=0.0, max_digits=10)),
                ('route', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.route')),
                ('seat_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.seattype')),
            ],
        ),
        migrations.AddField(
            model_name='route',
            name='seat_types',
            field=models.ManyToManyField(through='ticket_management.RouteSeatType', to='ticket_management.seattype'),
        ),
        migrations.CreateModel(
            name='CancelledTicket',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('updated_at', models.DateTimeField(auto_now=True)),
                ('is_deleted', models.BooleanField(default=False)),
                ('pnr_number', models.CharField(max_length=10, unique=True)),
                ('route', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.route')),
                ('seat_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.seattype')),
                ('train', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='ticket_management.train')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
    ]
